<?php

	/**
	 * shortcut to show the podium for the users
	 * 
	 * @since version 1
	 * @version 1
	 * @access public
	 * @author Stefan de Bruin
	 * @global type $wpdb
	 * @return nothing show the template file
	 */
	function podium() {
		global $wpdb;
		$current_user = wp_get_current_user();
		
//		update_option('poule_podium_users', array());
		
		$users_only = array();
		$phases_only = array();
		
		if($_SERVER['REQUEST_METHOD'] == "POST"){
			if(isset($_POST['users'])){
				$users_only = $_POST['users'];
			}else{
				$users_only = array();
			}
			
			if(isset($_POST['phases'])){
				$phases_only = $_POST['phases'];
			}else{
				$phases_only = array();
			}
			
		}
		
		$podium = functions::create_podium($users_only, $phases_only);
		$phases = functions::pagination();
		foreach($phases as $key => $value){
			if(in_array($value['id'], $phases_only)){
				$phases[$key]['select'] = 'selected="selected"';
			}else{
				$phases[$key]['select'] = '';
			}
		}
		
		
		$users = functions::get_users();
		require_once POULE_PATH . 'shortcuts/podium.php';
	}

	add_shortcode('poule_podium', 'podium');

	/**
	 * shortcut to show the officla score
	 * 
	 * @since version 1
	 * @version 1
	 * @access public
	 * @author Stefan de Bruin
	 * @global type $wpdb
	 * @return nothing show the template file
	 */
	function officialscore() {
		global $wpdb;

		$groups = array();

		$phase = (isset($_GET['phase'])) ? $_GET['phase'] : "group";

		$phase_id = $wpdb->get_row('SELECT * FROM ' . $wpdb->prefix . "poule_phases WHERE name = '" . $phase . "'", ARRAY_A);
		if ($phase_id == null) {
			echo '<div class="alert alert-danger">no matches</div>';
			die();
		}
		$countries = array();
		foreach ($wpdb->get_results("SELECT * FROM " . $wpdb->prefix . "poule_countries", ARRAY_A) as $key => $value) {
			$countries[$value['id']] = $value['name'];
		}

		$i = 0;
		$scores_set = array();

		$groups = functions::Get_score($phase, TRUE);
		
		$pagination = functions::pagination();

		require_once POULE_PATH . 'shortcuts/poule_official_score.php';
	}

	add_shortcode('poule_official_score', 'officialscore');

	/**
	 * shortcut to view a form to set the match results
	 * 
	 * @since version 1
	 * @version 1
	 * @access public
	 * @author Stefan de Bruin
	 * @global type $wpdb
	 * @return nothing show the template file
	 */
	function set_score() {
		global $wpdb;

		if (!is_user_logged_in()) {
			echo '<div class="alert alert-danger">' . _e('Login required', 'poule-system') . ' link naar login form</div>';
		} else {

			$current_user = wp_get_current_user();

			$phase = (isset($_GET['phase'])) ? $_GET['phase'] : "group";

			$phase_id = $wpdb->get_row('SELECT * FROM ' . $wpdb->prefix . "poule_phases WHERE name = '" . $phase . "'", ARRAY_A);

			$groups = functions::Get_score($phase, FALSE, FALSE);
			$error = array();
			$next = TRUE;

			if ($_SERVER['REQUEST_METHOD'] == "POST") {
//				print_r($_POST);
				$matches = $groups['matches'];
				if (isset($_POST['score'])) {

					$input_score = $_POST['score'];

					foreach ($input_score as $match_id => $score) {
//						print_r($score);
						$match_info = $wpdb->get_row('SELECT * FROM ' . $wpdb->prefix . "poule_matches WHERE id = '" . $match_id . "'", ARRAY_A);
						$error[$match_id] = array();
						if ($matches[$match_id]['readonly'] == "") {
							if (preg_match('/^\d+$/', $score['score_1'])) {
								$groups[$match_info['group_id']]['matches'][$match_id]['score_1'] = $score['score_1'];
								$error[$match_id]['score_1'] = "has-success";
							} else {
								$next = FALSE;
								$error[$match_id]['score_1'] = "has-error";
							}

							if (preg_match('/^\d+$/', $score['score_2'])) {
								$groups[$match_info['group_id']]['matches'][$match_id]['score_2'] = $score['score_2'];
								$error[$match_id]['score_2'] = "has-success";
							} else {
								$next = FALSE;
								$error[$match_id]['score_2'] = "has-error";
							}
							if ($phase != "group") {
								if($score['score_1'] == $score['score_2']){
									if (preg_match('/^\d+$/', $score['penalty'])) {
										$error[$match_id]['penalty'] = "has-success";
									} else {
										$next = FALSE;
										$error[$match_id]['penalty'] = "has-error";
									}
								}else{
									$input_score[$match_id]['penalty'] = '';
								}
									
							}
						} else {
							$input_score[$match_id]['score_1'] = $matches[$match_id]['score_1'];
							$input_score[$match_id]['score_2'] = $matches[$match_id]['score_2'];
							$input_score[$match_id]['penalty'] = $matches[$match_id]['penalty'];

							$error[$match_id]['score_1'] = "has-warning";
							$error[$match_id]['score_2'] = "has-warning";
							$error[$match_id]['penalty'] = "has-warning";
						}
						$i++;
					}
				} else {
					$next =  FALSE;
				}

//				var_dump($next);
				if ($next) {
					$check = $wpdb->get_row('SELECT * FROM ' . $wpdb->prefix . "poule_score WHERE user_id = '" . $current_user->ID . "'phase = '" . $phase_id['id'] . "'", ARRAY_A);
					
					if ($check != null) {
						$update = array(
							'score' => serialize($input_score)
						);
						$where = array(
							'user_id' => $current_user->ID,
							'phase' => $phase_id['id']
						);

						$wpdb->update($wpdb->prefix . "poule_score", $update, $where);
					} else {
						$insert = array();
						$insert['user_id'] = $current_user->ID;
						$insert['phase'] = $phase_id['id'];
						$insert['score'] = serialize($input_score);
						
						$result = $wpdb->insert($wpdb->prefix . "poule_score", $insert);
						var_dump($wpdb->queries);
					}
				}
			}

			$groups = functions::Get_score($phase, FALSE, FALSE);
			$pagination = functions::pagination();

			require_once POULE_PATH . 'shortcuts/setscore.php';
		}
	}

	add_shortcode('poule_setscore', 'set_score');

	/**
	 * shortcut to view the user score
	 * 
	 * @since version 1
	 * @version 1
	 * @access public
	 * @author Stefan de Bruin
	 * @global type $wpdb
	 * @return nothing show the template file
	 */
	function ownscore() {

		global $wpdb;

		if (!is_user_logged_in()) {
			echo '<div class="alert alert-danger">' . __('Login required', 'poule-system') . '</div>';
		} else {

			$current_user = wp_get_current_user();

			$groups = array();

			$phase = (isset($_GET['phase'])) ? $_GET['phase'] : "group";

			$phase_id = $wpdb->get_row('SELECT * FROM ' . $wpdb->prefix . "poule_phases WHERE name = '" . $phase . "'", ARRAY_A);
			if ($phase_id == null) {
				echo '<div class="alert alert-danger">no matches</div>';
			}

			$groups = functions::Get_score($phase, FALSE, TRUE);
			$pagination = functions::pagination();

			require_once POULE_PATH . 'shortcuts/own_score.php';
		}
	}

	add_shortcode('poule_own_score', 'ownscore');
?>