<?php

/**
 * Class to set the settings for the plugin
 * 
 * @version 1
 * @author Stefan de bruin
 */
class poulesettings {

	/**
	 * Home function for the settings contains all the settings
	 * 
	 * @since version 1
	 * @version 1
	 * @access public
	 * @author Stefan de Bruin
	 */
	public function home() {
		if (!$settings_tournament_type = get_option('poule_phase_settings')) {
			$settings_tournament_type = '';
		}

		if (!$settings_load_files = get_option('poule_load_files')) {
			$settings_load_files = '';
		}
		
		if ($_SERVER['REQUEST_METHOD'] == "POST") {
			$settings_tournament_type = (isset($_POST['tournament_type'])) ? "WK" : "EK";
			update_option('poule_phase_settings', $settings_tournament_type);
			
			$settings_load_files = (isset($_POST['load_files'])) ? TRUE : FALSE;
			update_option('poule_load_files', $settings_load_files);
			
		}
		
		$tournament_type = ($settings_tournament_type == "WK") ? 'checked="checked"' : '';
		$load_files = ($settings_load_files === TRUE) ? 'checked="checked"' : '';
		
		require_once POULE_PATH . 'poule-admin/templates/poulesettings/home.php';
	}

}

?>
